//---------------------------------------------------------------------------

#ifndef TetrisUnitH
#define TetrisUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormPaint(TObject *Sender);
private:	// User declarations
    HDC m_hDC;
    HGLRC m_hRC;
    int m_iPixelFormat;
    


    bool __fastcall LoadGLTextures();
    bool __fastcall InitGL();
    bool __fastcall SetWindowStats(int iWidth_, int iHeight_, int iColor);
public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);

    void __fastcall RenderGLScene();
    void __fastcall SetPixelFormatDescriptor();
    void __fastcall CubDraw(float X, float Y, float Z, float H);
    void __fastcall BasketDraw(float X, float Y, float Z, float bH_, float bW_);

        enum rotate_mass {anticlockwise,clockwise};
        enum move_mass {M_left, M_right, rotate_cw, rotate_acw, M_down, M_drop};
        void __fastcall NewGame();
        void __fastcall FigureGrowth(bool f_g[15][15]);
        void __fastcall FigureRotation(rotate_mass rot);
        void __fastcall ShowFigure();
        void __fastcall ToRealFigure(bool r_f[8][8], bool f_g[15][15]);
        void __fastcall CopyFigMass(bool f_g[15][15],bool f_g_next[15][15]);
        void __fastcall InitFigure();
        void __fastcall AddToImageMass();
        void __fastcall CheckMove(move_mass m);
        void __fastcall AddFigToMass();
        void __fastcall CheckMass();
        void __fastcall DeleteLine(int d_line);
        void __fastcall WhenIdle(TObject *Sender, bool &Done);
        

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
